/*
 * LegoUSB Linux Kernel Driver v0.3
 * 	Linux Kernel Driver for the Lego USB IR Tower (From the Mindstorms RIS 2.0 Kit)
 *
 * Copyright (c) 2001-2002 The LegoUSB DevTeam <legousb-devteam@lists.sourceforge.net>
 *   - Portions Copyright (c) 2001 Bret Thaeler <bthaeler@aol.com>
 * 
 *  The LegoUSB DevTeam Is:
 * 	 - Brendan W. McAdams <rit@users.sourceforge.net>
 * 	 - Jrgen Stueber <starblue@users.sourceforge.net>
 * 	 - Andy Bianchi <abianchi@users.sourceforge.net>
 * 	 - Bret Thaeler <bthaeler@users.sourceforge.net>
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License as
 *	published by the Free Software Foundation; either version 2 of
 *	the License, or (at your option) any later version.
 *
 *
 * This drivers was based on code from the usb-skeleton USB drivers by:
 *   Greg Kroah-Hartman (greg@kroah.com) [Copyright (c) 2001 Greg Kroah-Hartman (greg@kroah.com)]
 *
 *
 * History:
 *
 * $Log: driver.h,v $
 * Revision 1.3  2003/01/20 03:39:37  huntd
 * Updated kernel module compile system to use GNU autoconf.  This is hopefully
 * more robust.
 *
 * Revision 1.1.1.1  2002/08/21 00:05:35  rit
 * Initial Import.
 *
 * This includes a proper NQC 2.4 r2 patch for USB Support, and a Linux driver.
 *
 * This is almost 100% Brets work at this point, although I've done some abstraction.
 *  
 * Things to note:
 *  - There are no docs yet =)
 *  - The Makefile for the driver is shitty.
 *  - NQC may have some hardcoded bits which prevent non-USB tower from working if built like this.  I did abstract away some of this hardcoding but no guarantees
 *
 *
 * Revision 1.1.1.1  2002/08/20 20:42:22  bmcadams
 * - BWM - 
 * Initial Import.
 *
 * This includes a proper NQC 2.4 r2 patch for USB Support, and a Linux driver.
 *
 * This is almost 100% Brets work at this point, although I've done some abstraction.
 *
 * Things to note:
 * - There are no docs yet =)
 * - The Makefile for the driver is shitty.
 * - NQC may have some hardcoded bits which prevent non-USB tower from working if built like this.  I did abstract away some of this hardcoding but no guarantees
 *
 * ---------------------------------------------------------------------
 * $Id: driver.h,v 1.3 2003/01/20 03:39:37 huntd Exp $
 */

typedef unsigned short Word;
typedef unsigned char  Byte;
typedef unsigned long  LWord;
#define __LTW_VENDREQ_NOTYPEDEFS__

#include <vendreq.h>

#define LEGO_TOWER_SET_PARAM _IOW('u', 0xb0, int)
#define LEGO_TOWER_GET_PARAM _IOW('u', 0xb1, int)
#define LEGO_TOWER_FLUSH _IOW('u', 0xb2, int)
#define LEGO_TOWER_RESET _IO('u', 0xb3)
#define LEGO_TOWER_GET_STAT _IOR('u', 0xb4, LTW_REQ_GET_STAT_REPLY)
#define LEGO_TOWER_GET_POWER _IO('u', 0xb5)
#define LEGO_TOWER_GET_LED _IOW('u', 0xb6, int)
#define LEGO_TOWER_SET_LED _IOW('u', 0xb7, int)
#define LEGO_TOWER_RESET_STAT _IO('u', 0xb8)
#define LEGO_TOWER_GET_PARAM_IRC _IOW('u', 0xb9, int)
#define LEGO_TOWER_SET_PARAM_IRC _IOW('u', 0xba, int)
#define LEGO_TOWER_GET_TX_SPEED _IO('u', 0xbb)
#define LEGO_TOWER_SET_TX_SPEED _IOW('u', 0xbc, int)
#define LEGO_TOWER_GET_RX_SPEED _IO('u', 0xbd)
#define LEGO_TOWER_SET_RX_SPEED _IOW('u', 0xbe, int)
#define LEGO_TOWER_GET_TX_STATE _IOR('u', 0xbf, LTW_REQ_GET_TX_STATE_REPLY)
#define LEGO_TOWER_GET_TX_CARRIER_FREQUENCY _IO('u', 0xc0)
#define LEGO_TOWER_SET_TX_CARRIER_FREQUENCY _IOW('u', 0xc1, int)
#define LEGO_TOWER_GET_TX_CARRIER_DUTY_CYCLE _IOW('u', 0xc2, int)
#define LEGO_TOWER_SET_TX_CARRIER_DUTY_CYCLE _IOW('u', 0xc3, int)
#define LEGO_TOWER_GET_CAPS _IOWR('u', 0xc4, LTW_REQ_GET_CAPS_REPLY)
#define LEGO_TOWER_GET_VERSION _IOR('u', 0xc5, LTW_REQ_GET_VERSION_REPLY)
#define LEGO_TOWER_GET_COPYRIGHT _IOWR('u', 0xc6, LTW_REQ_GET_COPYRIGHT_REPLY)
#define LEGO_TOWER_GET_CREDITS _IOWR('u', 0xc7, LTW_REQ_GET_CREDITS_REPLY)

#define LEGO_TOWER_SET_READ_TIMEOUT _IOW('u', 0xc8, int)
#define LEGO_TOWER_SET_WRITE_TIMEOUT _IOW('u', 0xc9, int)
