/*
 * 
 *  dynamic linker command file
 *  generated: Thu Mar  6 15:52:18 2003

 *  kernel   : brickOS
 *  app start: 0xae8c
 * 
 *  BrickOS for LEGO(R) Mindstorms(TM)
 *  Originally: legOS - the independent LEGO Mindstorms OS
 *              (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2e8c
  ram   : o = 0xae8c, l = 0x5070
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _rom_reset_vector = 0xffff8000 ;
    _reset = 0xffff83ae ;
    rom_memcpy = 0xffff842a ;
    _rom_dummy_handler = 0xffff846a ;
    _rom_ocia_handler = 0xffff84cc ;
    _rom_ocia_return = 0xffff84d4 ;
    lcd_show = 0xffff9b62 ;
    lcd_hide = 0xffff9e4a ;
    lcd_number = 0xffff9ff2 ;
    lcd_clear = 0xffffa7ac ;
    power_init = 0xffffa964 ;
    sound_system = 0xffffa99a ;
    power_off = 0xffffaa62 ;
    sound_playing = 0xffffbccc ;
    _kmain = 0x0000 ;
    _mm_try_join = 0x00f6 ;
    _mm_defrag = 0x0138 ;
    _mm_update_first_free = 0x0178 ;
    _mm_init = 0x019e ;
    _malloc = 0x0206 ;
    _free = 0x02b4 ;
    _calloc = 0x02de ;
    _mm_reaper = 0x0326 ;
    _mm_free_mem = 0x0358 ;
    _clock_handler = 0x0392 ;
    _subsystem_handler = 0x03b6 ;
    _task_switch_handler = 0x0418 ;
    _systime_tm_return = 0x0432 ;
    _systime_init = 0x0446 ;
    _systime_shutdown = 0x04be ;
    _systime_set_switcher = 0x04d0 ;
    _systime_set_timeslice = 0x04d6 ;
    _get_system_up_time = 0x04f4 ;
    _tm_switcher = 0x050a ;
    _tm_scheduler = 0x0526 ;
    _yield = 0x06d6 ;
    _tm_man_task = 0x06f4 ;
    _tm_battery_task = 0x0748 ;
    _tm_init = 0x0792 ;
    _tm_start = 0x0800 ;
    _execi = 0x0812 ;
    _exit = 0x09de ;
    _wait_event = 0x0a00 ;
    _msleep = 0x0aaa ;
    _sleep = 0x0ae2 ;
    _shutdown_task = 0x0b06 ;
    _shutdown_tasks = 0x0b12 ;
    _kill = 0x0b64 ;
    _killall = 0x0b9c ;
    _sem_event_wait = 0x0c28 ;
    _sem_wait = 0x0c3e ;
    _sem_trywait = 0x0c6e ;
    _sem_post = 0x0c86 ;
    _delay = 0x0c96 ;
    _cputc_native = 0x0cb0 ;
    _cputc_native_0 = 0x0cde ;
    _cputc_native_1 = 0x0d12 ;
    _cputc_native_2 = 0x0d48 ;
    _cputc_native_3 = 0x0d82 ;
    _cputc_native_4 = 0x0dbe ;
    _cputc_native_5 = 0x0dfa ;
    _cputw = 0x0e06 ;
    _cputs = 0x0e4a ;
    _cls = 0x0e98 ;
    _lcd_number = 0x0ea0 ;
    _lcd_refresh_next_byte = 0x0f3e ;
    _lcd_refresh_next_byte_core = 0x0f52 ;
    _lcd_refresh = 0x0f98 ;
    _lcd_power_on = 0x0fb8 ;
    _lcd_power_off = 0x0fca ;
    _lcd_init = 0x0fe6 ;
    _rx_handler = 0x102c ;
    _rx_core = 0x1040 ;
    _rxerror_handler = 0x10b0 ;
    _rxerror_core = 0x10c4 ;
    _txend_handler = 0x1106 ;
    _txend_core = 0x111a ;
    _tx_handler = 0x1128 ;
    _tx_core = 0x113c ;
    _lnp_logical_shutdown = 0x1162 ;
    _lnp_logical_init = 0x1182 ;
    _lnp_logical_write = 0x122c ;
    _lnp_integrity_write = 0x12f6 ;
    _lnp_addressing_write = 0x135c ;
    _lnp_receive_packet = 0x13ec ;
    _lnp_integrity_byte = 0x147e ;
    _lnp_integrity_reset = 0x169c ;
    _lnp_integrity_reset_core = 0x16b0 ;
    _lnp_timeout_reset = 0x16dc ;
    _lnp_timeout_reset_core = 0x16f0 ;
    _lnp_init = 0x16fa ;
    _msg_received = 0x172e ;
    _send_msg = 0x1790 ;
    _lnp_integrity_active = 0x17ee ;
    _lnp_timeout_set = 0x17fa ;
    _lr_getdata = 0x1804 ;
    _lr_process = 0x182c ;
    _lr_waitdata = 0x18a6 ;
    _lr_thread = 0x18da ;
    _lr_init = 0x191a ;
    _lr_startup = 0x1924 ;
    _lr_shutdown = 0x1968 ;
    _program_valid = 0x197c ;
    _program_stop = 0x1d34 ;
    _key_handler = 0x1dc0 ;
    _lrkey_handler = 0x207a ;
    _program_init = 0x2276 ;
    _program_shutdown = 0x22d2 ;
    _vis_handler = 0x22de ;
    _vis_core = 0x22f2 ;
    _get_battery_mv = 0x234a ;
    _shutoff_restart = 0x2374 ;
    _shutoff_init = 0x2384 ;
    _autoshutoff_check = 0x2390 ;
    _autoshutoff_check_core = 0x23a4 ;
    _dkey_handler = 0x23d4 ;
    _dkey_pressed = 0x2412 ;
    _dkey_released = 0x2434 ;
    _getchar = 0x2454 ;
    _dm_init = 0x247c ;
    _dm_shutdown = 0x2480 ;
    _motor_a_dir = 0x24a2 ;
    _motor_b_dir = 0x24e4 ;
    _motor_c_dir = 0x252a ;
    _ds_rotation_set = 0x256e ;
    _ds_rotation_handler = 0x25c2 ;
    _ds_init = 0x26ae ;
    _ds_shutdown = 0x26e4 ;
    _dsound_handler = 0x26fc ;
    _dsound_core = 0x2710 ;
    _dsound_init = 0x2804 ;
    _dsound_shutdown = 0x281c ;
    _dsound_stop = 0x2820 ;
    _dsound_finished = 0x2840 ;
    _locked_increment = 0x285a ;
    _locked_decrement = 0x286a ;
    _locked_check_and_increment = 0x287a ;
    _wait_critical_section = 0x28b4 ;
    _enter_critical_section = 0x28d6 ;
    _setjmp = 0x2906 ;
    _longjmp = 0x2922 ;
    _memcpy = 0x2936 ;
    _memset = 0x2946 ;
    ___mulhi3 = 0x2954 ;
    ___udivhi3 = 0x2964 ;
    ___mulsi3 = 0x2976 ;
    ___divsi3 = 0x2992 ;
    _hex_display_codes = 0x29d0 ;
    _ascii_display_codes = 0x29e0 ;
    _lnp_rcx_header = 0x2a72 ;
    _lnp_rcx_remote_op = 0x2a74 ;
    _lnp_rcx_msg_op = 0x2a76 ;
    _min_length = 0x2aa4 ;
    _dm_a_pattern = 0x2ad4 ;
    _dm_b_pattern = 0x2ad8 ;
    _dm_c_pattern = 0x2adc ;
    ___ctors = 0x2bbe ;
    ___ctors_end = 0x2bbe ;
    ___dtors = 0x2bbe ;
    ___dtors_end = 0x2bbe ;
    _firmware_string = 0x2bbe ;
    _etext = 0x2bbe ;
    _lcd_refresh_period = 0x2bc0 ;
    _lnp_hostaddr = 0x2bc2 ;
    _lnp_timeout = 0x2bc4 ;
    _lr_dataready = 0x2bc6 ;
    _vis_refresh_counter = 0x2bc8 ;
    _vis_refresh_period = 0x2bc9 ;
    _battery_refresh_counter = 0x2bca ;
    _battery_refresh_period = 0x2bcc ;
    _auto_shutoff_counter = 0x2bce ;
    _auto_shutoff_period = 0x2bd0 ;
    _auto_shutoff_secs = 0x2bd2 ;
    _auto_shutoff_elapsed = 0x2bd4 ;
    _idle_powerdown = 0x2bd6 ;
    _dsound_system_sounds = 0x2bd8 ;
    __edata = 0x2bda ;
    _bss_start = 0x2be0 ;
    _mm_first_free = 0x2dca ;
    _tm_timeslice = 0x2dcc ;
    _tm_current_slice = 0x2dcd ;
    _tm_switcher_vector = 0x2dce ;
    _sys_time = 0x2dd0 ;
    _ctid = 0x2de0 ;
    _td_single = 0x2df0 ;
    _nb_tasks = 0x2e04 ;
    _priority_head = 0x2e06 ;
    _nb_system_tasks = 0x2e08 ;
    _lcd_byte_counter = 0x2e0a ;
    _lcd_refresh_counter = 0x2e0b ;
    _tx_state = 0x2e0c ;
    _lnp_rcx_checksum = 0x2e10 ;
    _lnp_integrity_handler = 0x2e12 ;
    _lnp_rcx_message = 0x2e14 ;
    _lnp_rcx_temp1 = 0x2e15 ;
    _lnp_timeout_counter = 0x2e16 ;
    _lnp_fast_block_handler = 0x2e18 ;
    _lnp_addressing_handler = 0x2e20 ;
    _lnp_remote_handler = 0x2e40 ;
    _lnp_integrity_state = 0x2e42 ;
    _lnp_rcx_temp0 = 0x2e44 ;
    _lr_curkeys = 0x2e48 ;
    _lr_data = 0x2e4a ;
    _EventType = 0x2e4c ;
    _lr_handler = 0x2e4e ;
    _lr_tid = 0x2e50 ;
    _lr_timeoff = 0x2e54 ;
    _packet_len = 0x2e58 ;
    _cprog = 0x2e5a ;
    _packet_src = 0x2e5c ;
    _dkey_timer = 0x2e5e ;
    _dkey = 0x2e5f ;
    _dkey_multi = 0x2e60 ;
    _dm_a = 0x2e64 ;
    _dm_b = 0x2e68 ;
    _dm_c = 0x2e6c ;
    _ds_rotation = 0x2e70 ;
    _ds_channel = 0x2e71 ;
    _ds_rotations = 0x2e74 ;
    _ds_activation = 0x2e7a ;
    _dsound_next_note = 0x2e7c ;
    _dsound_internote_ms = 0x2e7e ;
    _dsound_16th_ms = 0x2e80 ;
    _dsound_next_time = 0x2e84 ;
    _kernel_critsec_count = 0x2e88 ;
    _end = 0x2e8a ;
    _mm_start = 0x2e8a ;
    _display_memory = 0x6f43 ;
    _dm_handler = 0x7002 ;
    ___etext_hi = 0x704a ;
    _rom_port1_ddr = 0x7d80 ;
    _rom_port2_ddr = 0x7d81 ;
    _rom_port3_ddr = 0x7d82 ;
    _rom_port4_ddr = 0x7d83 ;
    _rom_port5_ddr = 0x7d84 ;
    _rom_port6_ddr = 0x7d85 ;
    _rom_port7_pin = 0x7d86 ;
    _reset_vector = 0x7d90 ;
    _nmi_vector = 0x7d92 ;
    _irq0_vector = 0x7d94 ;
    _irq1_vector = 0x7d96 ;
    _irq2_vector = 0x7d98 ;
    _icia_vector = 0x7d9a ;
    _icib_vector = 0x7d9c ;
    _icic_vector = 0x7d9e ;
    _icid_vector = 0x7da0 ;
    _ocia_vector = 0x7da2 ;
    _ocib_vector = 0x7da4 ;
    _fovi_vector = 0x7da6 ;
    _cmi0a_vector = 0x7da8 ;
    _cmi0b_vector = 0x7daa ;
    _ovi0_vector = 0x7dac ;
    _cmi1a_vector = 0x7dae ;
    _cmi1b_vector = 0x7db0 ;
    _ovi1_vector = 0x7db2 ;
    _eri_vector = 0x7db4 ;
    _rxi_vector = 0x7db6 ;
    _txi_vector = 0x7db8 ;
    _tei_vector = 0x7dba ;
    _ad_vector = 0x7dbc ;
    _wovf_vector = 0x7dbe ;
    _stack = 0x7e00 ;
    _motor_controller = 0x7f80 ;
    _T_IER = 0x7f90 ;
    _T_CSR = 0x7f91 ;
    _T_CNT = 0x7f92 ;
    _T_OCRA = 0x7f94 ;
    _T_OCRB = 0x7f94 ;
    _T_CR = 0x7f96 ;
    _T_OCR = 0x7f97 ;
    _T_ICRA = 0x7f98 ;
    _T_ICRB = 0x7f9a ;
    _T_ICRC = 0x7f9c ;
    _T_ICRD = 0x7f9e ;
    _WDT_CSR = 0x7fa8 ;
    _WDT_CNT = 0x7fa9 ;
    _PORT1_PCR = 0x7fac ;
    _PORT2_PCR = 0x7fad ;
    _PORT3_PCR = 0x7fae ;
    _PORT1_DDR = 0x7fb0 ;
    _PORT2_DDR = 0x7fb1 ;
    _PORT1 = 0x7fb2 ;
    _PORT2 = 0x7fb3 ;
    _PORT3_DDR = 0x7fb4 ;
    _PORT4_DDR = 0x7fb5 ;
    _PORT3 = 0x7fb6 ;
    _PORT4 = 0x7fb7 ;
    _PORT5_DDR = 0x7fb8 ;
    _PORT6_DDR = 0x7fb9 ;
    _PORT5 = 0x7fba ;
    _PORT6 = 0x7fbb ;
    _PORT7 = 0x7fbe ;
    _STCR = 0x7fc3 ;
    _SYSCR = 0x7fc4 ;
    _T0_CR = 0x7fc8 ;
    _T0_CSR = 0x7fc9 ;
    _T0_CORA = 0x7fca ;
    _T0_CORB = 0x7fcb ;
    _T0_CNT = 0x7fcc ;
    _T1_CR = 0x7fd0 ;
    _T1_CSR = 0x7fd1 ;
    _T1_CORA = 0x7fd2 ;
    _T1_CORB = 0x7fd3 ;
    _T1_CNT = 0x7fd4 ;
    _S_MR = 0x7fd8 ;
    _S_BRR = 0x7fd9 ;
    _S_CR = 0x7fda ;
    _S_TDR = 0x7fdb ;
    _S_SR = 0x7fdc ;
    _S_RDR = 0x7fdd ;
    _AD_A = 0x7fe0 ;
    _AD_A_H = 0x7fe0 ;
    _AD_A_L = 0x7fe1 ;
    _AD_B = 0x7fe2 ;
    _AD_B_H = 0x7fe2 ;
    _AD_B_L = 0x7fe3 ;
    _AD_C = 0x7fe4 ;
    _AD_C_H = 0x7fe4 ;
    _AD_C_L = 0x7fe5 ;
    _AD_D = 0x7fe6 ;
    _AD_D_H = 0x7fe6 ;
    _AD_D_L = 0x7fe7 ;
    _AD_CSR = 0x7fe8 ;
    _AD_CR = 0x7fe9 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _WDT_CSR = 0xa8 ;
    _WDT_CNT = 0xa9 ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
