 /*! \file   test program for the FAST_BLOCK IR transmission
    \brief   test program for the FAST_BLOCK IR transmission
    \author Jacky Baltes <j.baltes@auckland.ac.nz>
*/
    
/*
 *  The contents of this file are subject to the Mozilla Public License
 *  Version 1.0 (the "License"); you may not use this file except in
 *  compliance with the License. You may obtain a copy of the License at
 *  http://www.mozilla.org/MPL/
 *
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *
 */

#include <conio.h>
#include <unistd.h>
#include <lnp/lnp.h>

static volatile unsigned int val = 0;

void handler(const unsigned char *data,unsigned char len) 
{
  val = (int) data[1];
}

int main(int argc, char **argv) {
  lnp_init();

  lnp_fast_block_set_handler( (lnp_integrity_handler_t) handler);

  for( ;; )
    {
      lcd_int( val );
      val = 0;
      sleep(2);
    }
  return 0;
}
